#include "stdafx.h"
#include "SliderDefUI.h"

IMPLEMENT_RTTI(CSliderDefUI, INSliderUI)

CSliderDefUI::CSliderDefUI(CNSlider* pSlider, 
						   PSLIDERDEFUI_ITEM pUiItem)
{
	ATLASSERT(IS_KIND_OF(CNSlider, pSlider) == TRUE);
	m_pSlider = pSlider;

	ATLASSERT(pUiItem);
	ATLASSERT(this->_IsValidateUiItem() == TRUE);
	::CopyMemory(&m_UiItem, pUiItem, sizeof(SLIDERDEFUI_ITEM));
}

CSliderDefUI::~CSliderDefUI()
{

}

void CSliderDefUI::DrawSlider(	HDC hDC, 
								LPRECT prcSlider, 
								LPRECT prcThumb, 
								CStateControl::eControlState eSliderState, 
								CStateControl::eControlState eThumbState )
{
	CRect rcThumbStart;
	m_pSlider->GetThumbStartRect(&rcThumbStart);
	CRect rcThumbEnd;
	m_pSlider->GetThumbEndRect(&rcThumbEnd);
	CRect rcRail;
	m_pSlider->GetRailRect(&rcRail);

	// PM-844 2007/10/31 17:17:37 
	/* {kr}
		̸, ķ ڸ ʱȭ Ҷ Thumb RECT ȿ ˻縦 .
	{/kr} */
	BOOL brcThumbValidate = (prcThumb->left >= rcThumbStart.left) && 
							(prcThumb->right <= rcThumbEnd.right) &&
							(prcThumb->top == rcThumbStart.top) &&
							(prcThumb->bottom == rcThumbStart.bottom);
	
	IImage* pImgBgLT = m_UiItem.pImgBgLeftTop;
	IImage* pImgBgRB = m_UiItem.pImgBgRightBottom;
	IImage* pImgBgCenter = m_UiItem.pImgBgCenter;
	IImage* pImgPast = m_UiItem.pImgPast;
	IImage* pImgThumb = m_UiItem.pImgThumb;

	CRect rcSrcBgLT(0, 0, pImgBgLT->GetWidth(), pImgBgLT->GetHeight());
	CRect rcSrcBgRB(0, 0, pImgBgRB->GetWidth(), pImgBgRB->GetHeight());
	CRect rcSrcBgCenter(0, 0, pImgBgCenter->GetWidth(), pImgBgCenter->GetHeight());
	CRect rcSrcPast(0, 0, pImgPast->GetWidth(), pImgPast->GetHeight());

	if (CNSlider::E_SLIDER_DIRECTION_HORZ == m_pSlider->GetDirection())
	{
		CRect rcDestBgLT(&rcSrcBgLT);
		rcDestBgLT.MoveToXY(rcRail.left, rcRail.top);
		pImgBgLT->DrawImage(hDC, &rcSrcBgLT, &rcDestBgLT);

		CRect rcDestBgRB(&rcSrcBgRB);
		rcDestBgRB.MoveToXY(rcRail.right - rcDestBgRB.Width(), rcRail.top);
		pImgBgRB->DrawImage(hDC, &rcSrcBgRB, &rcDestBgRB);

		CRect rcDestBgCenter(rcDestBgLT.right, rcDestBgLT.top, rcDestBgRB.left, rcDestBgRB.bottom);
		pImgBgCenter->DrawImage(hDC, &rcSrcBgCenter, &rcDestBgCenter);

		if (brcThumbValidate == TRUE)
		{
			CRect rcDestPast(&rcDestBgCenter);
			rcDestPast.right = (prcThumb->left + prcThumb->right) / 2;
			BOOL bResult = rcDestPast.IsRectEmpty();
			if (bResult == FALSE)
			{
				pImgPast->DrawImage(hDC, &rcSrcPast, &rcDestPast);
			}
		}

		///< Thumb Draw Logic.
		///< Thumb is drawn with its states.
		int nThumbState = 0;
		if(CStateControl::E_CONTROLSTATE_NORMAL == eThumbState)
		{
			nThumbState = 0;
		}
		else if(CStateControl::E_CONTROLSTATE_OVER == eThumbState)
		{
			nThumbState = 1;
		}
		else if(CStateControl::E_CONTROLSTATE_DOWN == eThumbState)
		{
			nThumbState = 2;
		}
		else if(CStateControl::E_CONTROLSTATE_DIS == eThumbState)
		{
			nThumbState = 3;
		}

		if (m_pSlider->GetFocus() == &(m_pSlider->m_Panel_Thumb))
		{
			nThumbState = 1;
		}

		CRect rcSrcThumb(0, 0, pImgThumb->GetWidth() / 4, pImgThumb->GetHeight());
		rcSrcThumb.MoveToX(pImgThumb->GetWidth() * nThumbState / 4);
		pImgThumb->DrawImage(hDC, &rcSrcThumb, prcThumb);
	}
}

BOOL CSliderDefUI::_IsValidateUiItem()
{
	BOOL bIsValidate = m_UiItem.pImgBgCenter != NULL;
	BOOL bReturn = bIsValidate;
	
	bIsValidate = m_UiItem.pImgBgLeftTop != NULL;
	bReturn = bReturn && bIsValidate;
	
	bIsValidate = m_UiItem.pImgBgRightBottom != NULL;
	bReturn = bReturn && bIsValidate;

	bIsValidate = m_UiItem.pImgPast != NULL;
	bReturn = bReturn && bIsValidate;
	
	bIsValidate = m_UiItem.pImgThumb != NULL;
	bReturn = bReturn && bIsValidate;
	
	return bReturn;
}